//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt
//
//----------------------------------------------------------------------------
// File Name           : Smeter.h
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20080111
//----------------------------------------------------------------------------

#define GRAPHIC	0
#define NUMERIC	1
#define POWERMETER	2
#define SMETERSTEPS	12
#define SMETERVALUESTEPS	10
//#define SMETERVALUESTEPS	50
#define SMETERMAXVALUE	5000
#define SMETER_ADCCHANNEL 0x40
#define SMETER_VOLTCHANNEL 0x00


extern volatile WORD ramSmeterValues [ 12 ];
extern volatile BYTE ControlChanged;
extern volatile BYTE AlreadyFound;
extern volatile BYTE menuPosRow;
extern volatile BYTE menuPosCol;
extern	volatile BYTE SMeterMode;
extern const WORD cSmeterValues [ 12 ];
extern const char cSetSMeterCal [];
extern const char cSaveWith [];
extern const char cContinueWith [];
extern const char cSMeterCalNow [];
extern const char cSMeterCalStep [];
extern const char cSaveWith [];
extern const char cSkipSaveWith [];
extern const char cSMeterTypStart [];
extern const char cSMeterGraph [];
extern const char cSMeterNumeric [];
extern const char cSMeterTyp [];

void	MakeSmeterCharacters ( void );
void ShowSMeterValue ( UINT SMeterValue, BYTE mode, BYTE position );
void ShowVoltageValue ( UINT SMeterValue, BYTE position );
void	SetSMeterCalStart ( void );
void	SetSMeterCal ( void );
void	SetSMeterCalSave ( void );
BYTE	GetSMeterValue ( void );
WORD	GetVoltageMeterValue ( BYTE channel );
void	SetupSMetertype ( void );
void	SetupSMetertypeStart ( void );
void SetupDVMStart ( void );
void SetupDVM ( void );

