//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt
//
//----------------------------------------------------------------------------
// File Name           : TWI_ctrl.h
// Object              : QROlleSAM7S Board Features Definition File.
//
// Creation            : NSn   20070525
//----------------------------------------------------------------------------
#ifndef TWI_CTRL_H_
#define TWI_CTRL_H_

// Address def's in PCA9535 via TWI aka I2C


#define OnboardPCA9535address_Write			0x40			
#define OnboardPCA9535address_Read			0x41	

#define ComboPCA9535address_Write				0x4C			
#define ComboPCA9535address_Read				0x4D	
		

#define PCA9535_CMD_INPUT_A							0
#define PCA9535_CMD_INPUT_B							1
#define PCA9535_CMD_OUTPUT_A						2
#define PCA9535_CMD_OUTPUT_B						3
#define PCA9535_CMD_POL_INVERSION_A			4
#define PCA9535_CMD_POL_INVERSION_B			5
#define PCA9535_CMD_OUTPUT_CONFIG_A			6
#define PCA9535_CMD_OUTPUT_CONFIG_B			7

#define PCA9535_VALUE_POL_INVERSION_A		0
#define PCA9535_VALUE_POL_INVERSION_B		0

// All port 0 are outputs
//#define OnboardPCA9535_VALUE_OUTPUT_CONFIG_0		0x00 
// Some port 1 are outputs
//#define OnboardPCA9535_VALUE_OUTPUT_CONFIG_1		0xF8 

#define AT91_TWI_READ_OK			0
#define AT91_TWI_WRITE_OK			0

extern int AT91_TWI_Write (const AT91PS_TWI, BYTE, BYTE *, int );
extern int AT91_TWI_Read  (const AT91PS_TWI, int address, int subaddress, BYTE *data, int count);
extern void AT91_TWI_Write_2_both_ports ( BYTE data2send0, BYTE data2send1 );
extern int TWI_Read_PCA9535_port ( BYTE device, BYTE subaddress, BYTE *data, BYTE size );
extern int TWI_Write_PCA9535_port ( BYTE device, BYTE subaddress, BYTE *data, BYTE size );


#endif /*TWI_CTRL_H_*/
