//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//
//  This code is distributed under the GNU Public License
//  which can be found at http://www.gnu.org/licenses/gpl.txt

/*----------------------------------------------------------------------------
* File Name           : display.c
* Object              : SmartFront4G ADC control header File.
*
* Creation            : NSn   20070314
*----------------------------------------------------------------------------
*/

//#define StartBit				0x04
//#define SingelBit				0x02
//#define HighBitAddress	0x01

//#define AdcAddress0			0x00
//#define AdcAddress1			0x40

#define StartBit				0x100
#define SingelBit				0x80
#define HighBitAddress	0x20

#define AdcAddress0			0x00
#define AdcAddress1			0x40

/* ADC field definition for the Mode Register: Reminder
                       TRGEN    => Selection bewteen Software or hardware start of conversion
                       TRGSEL   => Relevant if previous field is set on hardware triggering
                       LOWRES   => 10-bit result if ths bit is cleared 0
                       SLEEP    => normal mode if this is cleared
                       PRESCAL  => ADCclock = MCK / [(PRESCAL + 1)*2]
                       STARTUP  => Startup Time = [(STARTUP + 1)*8] / ADCclock
                       SHTIM    => Tracking time = (SHTIM + 1) / ADCclock
 */
#define   TRGEN    (0x0)    // Software triggering
#define   TRGSEL   (0x0)    // Without effect
#define   LOWRES   (0x0)    // 10-bit result output
#define   SLEEP    (0x0)    // Normal Mode
#define   PRESCAL  (0x9)    // Max value
#define   STARTUP  (0x7)    // This time period must be higher than 20 s and not 20 ms
#define   SHTIM    (0x3)    // Must be higher than 3 ADC clock cycles but depends on output
                            // impedance of the analog driver to the ADC input


WORD GetADCvalue ( BYTE channel, AT91PS_SPI pSPI );
WORD	GetAT91SAM_ADCvalue ( BYTE AdcChannel );
void	SetupAT91SAM_ADC ( void );

