/* Copyright (C) 2005 MediTalk AB 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
//  *******************************************************
//                Header Files
//  *******************************************************

#include "board.h"
#include "display.h"
#include <string.h> 
#include "serialARM.h"
#include "eepromhandler.h"
#include "menu.h"
#include "serialARM.h"
#include "commands.h"

struct  ArrayPtr
{
  const WORD        Command;
  const WORD        Definitions;
  const void    (* FuncPointer)();  
//  const void *   FuncPointer;
}; 
struct Array2Ptr
{
  WORD        Command;
  WORD        Definitions;
}; 
#define InOutBufferSize  16
volatile static char InBuffer [ InOutBufferSize ];
volatile         char OutBuffer [ InOutBufferSize ];
volatile 			  char OutBufferUSB [ InOutBufferSize ];

const struct ArrayPtr CmdPtr [] = {{(256*'A'+'B'),(WORD)(Kenwood + Yaesu), (void*)VfoA2VfoB }, 
                                    {(256*'A'+'C'), (WORD)(Kenwood + Yaesu), (void*)AntTuner },
                                    {(256*'A'+'G'), (WORD)(Kenwood + Yaesu), (void*)AFgain },
                                    {(256*'A'+'I'), (WORD)(Kenwood + Yaesu), (void*)AutoInfo },
                                    {(256*'A'+'N'), (WORD)(Kenwood + Yaesu), (void*)Antenn },
                                    {(256*'B'+'C'), (WORD)(Kenwood + Yaesu), (void*)AutoNotch },
                                    {(256*'B'+'D'), (WORD)(Kenwood + Yaesu), (void*)BandDown },
                                    {(256*'B'+'I'), (WORD)(Kenwood + Yaesu), (void*)BreakIn },
                                    {(256*'B'+'P'), (WORD)(Kenwood + Yaesu), (void*)ManualNotch },
																		{(256*'B'+'S'), (WORD)(Kenwood + Yaesu), (void*)BandSelect },
	                                  {(256*'B'+'U'), (WORD)(Kenwood + Yaesu), (void*)BandUp },
	                                  {(256*'B'+'Y'), (WORD)(Kenwood + Yaesu), (void*)IsBusy },
                                    {(256*'C'+'O'), (WORD)(Kenwood + Yaesu), (void*)Contour },
                                    {(256*'C'+'S'), (WORD)(Kenwood + Yaesu), (void*)CWspot },
                                    {(256*'C'+'T'), (WORD)(Kenwood + Yaesu), (void*)CTSS },
                                    {(256*'D'+'A'), (WORD)(Kenwood + Yaesu), (void*)Dimmer },
                                    {(256*'D'+'N'), (WORD)(Kenwood + Yaesu), (void*)MicDown },
                                    {(256*'D'+'P'), (WORD)(Kenwood + Yaesu), (void*)Displaying },
                                    {(256*'D'+'S'), (WORD)(Kenwood + Yaesu), (void*)DimmerSwitch },
                                    {(256*'F'+'A'), (WORD)(Kenwood + Yaesu), (void*)FQAsetting },
                                    {(256*'F'+'B'), (WORD)(Kenwood + Yaesu), (void*)FQBsetting },
                                    {(256*'F'+'K'), (WORD)(Kenwood + Yaesu), (void*)FunctionKey },
                                    {(256*'F'+'R'), (WORD)(Kenwood + Yaesu), (void*)FunctionRX },
                                    {(256*'F'+'S'), (WORD)(Kenwood + Yaesu), (void*)FastStep },
                                    {(256*'F'+'T'), (WORD)(Kenwood + Yaesu), (void*)FunctionTX },
                                    {(256*'G'+'T'), (WORD)(Kenwood + Yaesu), (void*)AGCfunction },
                                    {(256*'I'+'D'), (WORD)(Kenwood + Yaesu), (void*)Ident },
                                    {(256*'I'+'F'), (WORD)(Kenwood + Yaesu), (void*)Info },
                                    {(256*'I'+'S'), (WORD)(Kenwood + Yaesu), (void*)IFshift },
                                    {(256*'K'+'P'), (WORD)(Kenwood + Yaesu), (void*)KeyPitch },
                                    {(256*'K'+'R'), (WORD)(Kenwood + Yaesu), (void*)Keyer },
                                    {(256*'K'+'S'), (WORD)(Kenwood + Yaesu), (void*)KeySpeed },
                                    {(256*'L'+'K'), (WORD)(Kenwood + Yaesu), (void*)DialLock },
                                    {(256*'M'+'D'), (WORD)(Kenwood + Yaesu), (void*)ModeSet },
                                    {(256*'M'+'G'), (WORD)(Kenwood + Yaesu), (void*)MicGain },
                                    {(256*'M'+'K'), (WORD)(Kenwood + Yaesu), (void*)ModeKey },
                                    {(256*'M'+'L'), (WORD)(Kenwood + Yaesu), (void*)MonitorLevel },
                                    {(256*'M'+'S'), (WORD)(Kenwood + Yaesu), (void*)MeterSw },
                                    {(256*'M'+'X'), (WORD)(Kenwood + Yaesu), (void*)MoxSet },
                                    {(256*'N'+'A'), (WORD)(Kenwood + Yaesu), (void*)Narrow },
                                    {(256*'N'+'B'), (WORD)(Kenwood + Yaesu), (void*)NoiseBlanker },
                                    {(256*'N'+'R'), (WORD)(Kenwood + Yaesu), (void*)NoiseReduction },
                                    {(256*'P'+'A'), (WORD)(Kenwood + Yaesu), (void*)PreAmpStatus },
                                    {(256*'P'+'C'), (WORD)(Kenwood + Yaesu), (void*)PowerCtrl },
                                    {(256*'P'+'R'), (WORD)(Kenwood + Yaesu), (void*)SpeechProcessor },
                                    {(256*'P'+'S'), (WORD)(Kenwood + Yaesu), (void*)PowerSwitch },
                                    {(256*'Q'+'S'), (WORD)(Kenwood + Yaesu), (void*)QuickSplit },
                                    {(256*'R'+'A'), (WORD)(Kenwood + Yaesu), (void*)RFattenuator },
                                    {(256*'R'+'C'), (WORD)(Kenwood + Yaesu), (void*)ClarClear },
                                    {(256*'R'+'D'), (WORD)(Kenwood + Yaesu), (void*)ClarDown },
                                    {(256*'R'+'F'), (WORD)(Kenwood + Yaesu), (void*)RoofFilter },
                                    {(256*'R'+'G'), (WORD)(Kenwood + Yaesu), (void*)RfGain },
                                    {(256*'R'+'I'), (WORD)(Kenwood + Yaesu), (void*)RadioInfo },
                                    {(256*'R'+'L'), (WORD)(Kenwood + Yaesu), (void*)NoiseReductionLevel },
                                    {(256*'R'+'M'), (WORD)(Kenwood + Yaesu), (void*)ReadMeter },
                                    {(256*'R'+'S'), (WORD)(Kenwood + Yaesu), (void*)RadioStatus },
                                    {(256*'R'+'T'), (WORD)(Kenwood + Yaesu), (void*)ClarOnOff },
                                    {(256*'R'+'U'), (WORD)(Kenwood + Yaesu), (void*)ClarUp },
                                    {(256*'S'+'C'), (WORD)(Kenwood + Yaesu), (void*)Scan },
                                    {(256*'S'+'D'), (WORD)(Kenwood + Yaesu), (void*)BreakInTime },
                                    {(256*'S'+'H'), (WORD)(Kenwood + Yaesu), (void*)Width },
                                    {(256*'S'+'M'), (WORD)(Kenwood + Yaesu), (void*)SMeter },
                                    {(256*'S'+'V'), (WORD)(Kenwood + Yaesu), (void*)SwapVFO },
                                    {(256*'T'+'S'), (WORD)(Kenwood + Yaesu), (void*)Txw },
                                    {(256*'T'+'X'), (WORD)(Kenwood + Yaesu), (void*)TxSet },
                                    {(256*'U'+'L'), (WORD)(Kenwood + Yaesu), (void*)Unlock },
                                    {(256*'U'+'P'), (WORD)(Kenwood + Yaesu), (void*)Up },
                                    {(256*'V'+'D'), (WORD)(Kenwood + Yaesu), (void*)VoxDelay },
                                    {(256*'V'+'G'), (WORD)(Kenwood + Yaesu), (void*)VoxGain },
                                    {(256*'V'+'S'), (WORD)(Kenwood + Yaesu), (void*)VFOselect },
                                    {(256*'V'+'X'), (WORD)(Kenwood + Yaesu), (void*)Vox },
																			{ 0 }, { 0 }, { 0 } };
#define ARRAYCOMMANDSIZE sizeof(struct CmdPtr[0])
#define COMMANDLISTSIZE (sizeof(CmdPtr)/sizeof(CmdPtr[0]))

volatile static BYTE		InputByteCount;
volatile static WORD    Command, CmdListPtr;
volatile        BYTE    AutoInformationFlag = 0;
volatile        BYTE    BreakinFlag = 0;


//+++++++++++++++++++++++++++++++++++++++++++++++++

BYTE	CommandHandle_RS232 ( void )
{
	InputByteCount = 0;
	if ( EndOfCommand_RS232 > 0 ) 
		EndOfCommand_RS232--;
	if ( !DataInReceiveBuffer() )
	{
		goto ErrorNoCmdRS232;
	};
	
	do
	{
		InBuffer [ InputByteCount ] = ReceiveByte();
	}	while (( InBuffer [ InputByteCount++ ] != ';' ) && 
							DataInReceiveBuffer() &&
						( InputByteCount < InOutBufferSize ));
	if ( InputByteCount >= InOutBufferSize )
	{
		goto ErrorNoCmdRS232;
	};
	Command = (( InBuffer [ 0 ] & 0xDF ) * 256 ) + 
						 ( InBuffer [ 1 ] & 0xDF );

	for ( CmdListPtr = 0; CmdListPtr < COMMANDLISTSIZE; CmdListPtr++ )
	{
			if (( CmdPtr [ CmdListPtr ].Command ) == Command ) 
				goto CommandExist;
	};
ErrorNoCmdRS232:
	InitUSART_ARM ();
	return ERROR_NO_COMMAND;
	  
	
CommandExist:
  TxCommand_RS232 = 1;

	(CmdPtr [ CmdListPtr ].FuncPointer)();
	
	TxCommand_RS232 = 0;
	return 0;

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

BYTE	CommandHandle_USB ( void )
{
	InputByteCount = 0;
	if ( EndOfCommand_USB > 0 ) 
		EndOfCommand_USB--;
	if ( !DataInReceiveBufferUSB() )
	{
		goto ErrorNoCmdUSB;
	};
	do
	{
		InBuffer [ InputByteCount ] = ReceiveByteUSB();
	}	while (( InBuffer [ InputByteCount++ ] != ';' ) && 
							DataInReceiveBufferUSB() &&
						( InputByteCount < InOutBufferSize ));
	if ( InputByteCount >= InOutBufferSize )
	{
		goto ErrorNoCmdUSB;
	};

	Command = (( InBuffer [ 0 ] & 0xDF ) * 256 ) + 
						 ( InBuffer [ 1 ] & 0xDF );

	for ( CmdListPtr = 0; CmdListPtr < COMMANDLISTSIZE; CmdListPtr++ )
	{
			if (( CmdPtr [ CmdListPtr ].Command ) == Command ) 
				goto CommandExist;
	};
ErrorNoCmdUSB:
	InitUSART_ARM ();
	return ERROR_NO_COMMAND;
	  

CommandExist:
  TxCommand_USB = 1;
	(CmdPtr [ CmdListPtr ].FuncPointer)();

	TxCommand_USB = 0;
	return 0;

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void VfoA2VfoB ( void )
{
  param.AD9834Bfrequency = param.AD9834Afrequency;
  SetAD9834value();
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void AntTuner ( void )
{
  BYTE  count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'A';
    OutBuffer [ 1 ] = 'C';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = ';';
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void AFgain ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'A';
    OutBuffer [ 1 ] = 'G';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = ';';
    MakeByte2string ( (char*)&OutBuffer [ 3 ], Pot1Volume, 0 );
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  Pot1Volume = MakeString2BYTE ( (char*)&InBuffer [ 3 ], 3 ); 
  ShowVolume = SHOWVOLUMEDELAY;
  SetPot1Volume();
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void AutoInfo ( void )
{
  BYTE      count;
  
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'A';
    OutBuffer [ 1 ] = 'I';
    if ( AutoInformationFlag )
      OutBuffer [ 2 ] = '1';
    else
      OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  if ( InBuffer [ 2 ] == '0' )
    AutoInformationFlag = 0;
  else
    AutoInformationFlag = 1;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void Antenn ( void )
{
  BYTE  count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'A';
    OutBuffer [ 1 ] = 'N';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '1';
    OutBuffer [ 4 ] = '1';
    OutBuffer [ 5 ] = ';';
		if ( InBuffer [ 2 ] == '2' )
		{
			OutBuffer [ 3 ] = '0';
			OutBuffer [ 4 ] = '0';
		};
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void AutoNotch ( void )
{
  BYTE  count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'B';
    OutBuffer [ 1 ] = 'C';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  BandDown ( void )
{
  SaveBandData ( Band, AddAD9834Afrequency, sizeof ( struct Parameters ));
  if ( Band > B160 )
  {
    Band--;
  }
  else
  {
    Band = Transverter;
  };
  SetBandData ( Band );
  ModeChanged = 1;  // Change DDS
  OutputdataDirty = 1; //Set/reset IO-bits
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void	BreakIn ( void )
{
  BYTE      count;
  
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'B';
    OutBuffer [ 1 ] = 'I';
    OutBuffer [ 2 ] = '0';
    if ( BreakinFlag )
      OutBuffer [ 2 ] = '1';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  if ( InBuffer [ 2 ] == '0' )
    BreakinFlag = 0;
  else
    BreakinFlag = 1;

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void	ManualNotch ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 5 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'B';
    OutBuffer [ 1 ] = 'P';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = InBuffer [ 3 ];
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = '0';
    OutBuffer [ 7 ] = ';';
		if ( InBuffer [ 3 ] == '1' )
		{
			OutBuffer [ 4 ] = '2';
		};
		
    for ( count = 0; count < 8; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  BandSelect ( void )
{
  SaveBandData ( Band, AddAD9834Afrequency, sizeof ( struct Parameters ));
  if (  InBuffer [ 2 ] == '0' )
	{
		switch ( InBuffer [ 3 ] )
		{
			case '0': Band = B160; break;
			case '1': Band = B80; break;
			case '2': Band = B40; break;
			case '3': Band = B30; break;
			case '4': Band = B20; break;
      case '5': Band = B17; break;
      case '6': Band = Transverter; break;
			default: ;
		};
	}
	else
	{
		if (  InBuffer [ 3 ] == '0' )
			Band = Transverter;
	};
  SetBandData ( Band );
  ModeChanged = 1;  // Change DDS
  OutputdataDirty = 1; //Set/reset IO-bits
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  BandUp ( void )
{
  SaveBandData ( Band, AddAD9834Afrequency, sizeof ( struct Parameters ));
  if ( Band < Transverter )
  {
    Band++;
  }
  else
  {
    Band = B160;
  };
  SetBandData ( Band );
  ModeChanged = 1;  // Change DDS
  OutputdataDirty = 1; //Set/reset IO-bits
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  IsBusy ( void )
{
  BYTE  count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'B';
    OutBuffer [ 1 ] = 'Y';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Contour ( void )
{
  BYTE     count;
  if  ( InputByteCount == 5 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'C';
    OutBuffer [ 1 ] = 'O';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = InBuffer [ 3 ];;
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = ';';
		if ( InBuffer [ 3 ] == '1' )
		{
			OutBuffer [ 4 ] = '2';
			OutBuffer [ 5 ] = '2';
		};
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
	};
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  CWspot ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'C';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  CTSS ( void )
{
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Dimmer ( void )
{
  BYTE			TXbuf [ 4 ];
	BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'D';
    OutBuffer [ 1 ] = 'A';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '7';
    OutBuffer [ 4 ] = '1';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = ';';
    if ( CheckBacklite )
		{
			OutBuffer [ 3 ] = '5';
			OutBuffer [ 5 ] = '9';
		};
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  if ( InBuffer [ 3 ] > '0' )
    SwitchONbacklite;
	else
	  SwitchOFFbacklite;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  MicDown ( void )
{
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  Displaying ( void )
{
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  DimmerSwitch ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'D';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '1';
    OutBuffer [ 3 ] = ';';
    if ( !CheckBacklite  )
		{
			OutBuffer [ 2 ] = '0';
		};
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  if ( InBuffer [ 2 ] == '1' )
    SwitchONbacklite;
	else
	  SwitchOFFbacklite;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  FQAsetting ( void )
{
  SetORsendFQvalue ( 'A', (UINT*)&param.AD9834Afrequency );
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  FQBsetting ( void )
{
  SetORsendFQvalue ( 'B', (UINT*)&param.AD9834Bfrequency );
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  FunctionKey ( void )
{
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  FastStep ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'F';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  FunctionRX ( void )
{
	BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'F';
    OutBuffer [ 1 ] = 'R';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if (( param.Modes & BFQmode ) == BFQmode )
		{
			OutBuffer [ 2 ] = '1';
		};
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	param.Modes &= ~BFQmode;
  if ( InBuffer [ 2 ] == '1' )
	{
			param.Modes = BFQmode;
	};
	ModeChanged = 1;
	OutputdataDirty = 1;  // Memorize changes
	SetAD9834value();
		
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  FunctionTX ( void )
{
	BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'F';
    OutBuffer [ 1 ] = 'T';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if ( bSPLITFQmode )	
		{
			if (( param.Modes & BFQmode ) == AFQmode )
			{
				OutBuffer [ 2 ] = '1';
			};
		}
		else
		{
			if (( param.Modes & BFQmode ) == BFQmode )
			{
				OutBuffer [ 2 ] = '1';
			};
		};
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  if ( InBuffer [ 2 ] == '0' )
	{
			if (( param.Modes & BFQmode ) == AFQmode )
			{
				bSPLITFQmode = 0;
				param.AD9834Bfrequency = param.AD9834Afrequency;
			}
			else
			{
				bSPLITFQmode = 1;
				param.AD9834Afrequency = param.AD9834Bfrequency;
			};
	}
	else
	{
			if (( param.Modes & BFQmode ) == AFQmode )
			{
				bSPLITFQmode = 1;
				param.AD9834Bfrequency = param.AD9834Afrequency;
			}
			else
			{
				bSPLITFQmode = 0;
				param.AD9834Afrequency = param.AD9834Bfrequency;
			};
	};
	ModeChanged = 1;
	OutputdataDirty = 1;  // Memorize changes
	SetAD9834value();
		
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  AGCfunction ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'G';
    OutBuffer [ 1 ] = 'T';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '2';
    OutBuffer [ 4 ] = ';';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Ident ( void )
{
  BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'I';
    OutBuffer [ 1 ] = 'D';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '2';
    OutBuffer [ 4 ] = '4';
    OutBuffer [ 5 ] = '1';
    OutBuffer [ 6 ] = ';';
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Info ( void )
{
  BYTE  count, len, Jdx;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'I';
    OutBuffer [ 1 ] = 'F';
    OutBuffer [ 2 ] = '0'; //Memory chamnnel
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0'; //First fq digit if under 30 m band
		len = ulong2string ( (char*)&NumberBuffer, param.AD9834Afrequency );
		for ( Jdx = 0; 
					 Jdx < len + 3; 
					 Jdx++ )
		{
				OutBuffer [ 5 + Jdx + 8 - len ] = NumberBuffer [ Jdx ];
    };
		for ( count = 0; count < 13; count++ )
      TransmitByte ( OutBuffer [ count ]);
    OutBuffer [ 0 ] = '+'; //Clarifier Offset
    OutBuffer [ 1 ] = '0';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0'; //RxClarOff
    OutBuffer [ 6 ] = '0'; //TxClarOff
		if ((  param.Modes &  LSBmode ) == CWmode  )
			OutBuffer [ 7 ] = '3';
		if ((  param.Modes &  LSBmode ) == LSBmode  )
			OutBuffer [ 7 ] = '1';
		if ((  param.Modes &  LSBmode ) == USBmode  )
			OutBuffer [ 7 ] = '2';
    OutBuffer [ 8 ]  = '0';  //Using VFO
    OutBuffer [ 9 ]  = '0';  //CTCSS off
    OutBuffer [ 10 ] = '0';  //CTCSS fq 67Hz
    OutBuffer [ 11 ] = '0';  //CTCSS fq 67Hz
    OutBuffer [ 12 ] = '0';  //Simplex
    OutBuffer [ 13 ] = ';';
		
		for ( count = 0; count < 14; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  IFshift ( void )
{
  BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'I';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '+';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = '0';
    OutBuffer [ 7 ] = '0';
    OutBuffer [ 8 ] = ';';
    for ( count = 0; count < 9; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
	};
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  KeyPitch ( void )
{
	BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'K';
    OutBuffer [ 1 ] = 'P';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '8';
    OutBuffer [ 4 ] = ';';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Keyer ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'K';
    OutBuffer [ 1 ] = 'R';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  KeySpeed ( void )
{	
	BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'K';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 5 ] = ';';
		MakeByte2string ((char*)&OutBuffer [ 2 ], ( wBugSpeed / 5 ), 0 );		
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	wBugSpeed = MakeString2WORD ( (char*)&InBuffer [ 3 ], 2 );
  wBugSpeed *= 5;
	if ( wBugSpeed < MINBUGSPEED )
		wBugSpeed = MINBUGSPEED;
	if ( wBugSpeed > MAXBUGSPEED )
		wBugSpeed = MAXBUGSPEED;
	ShowBugSpeed = SHOWBUGSPEED;	
	SetTimer4Bug ( wBugSpeed );
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  DialLock ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'L';
    OutBuffer [ 1 ] = 'K';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  ModeSet ( void )
{
	BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'M';
    OutBuffer [ 1 ] = 'D';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 4 ] = ';';
		if ((  param.Modes &  LSBmode ) == CWmode  )
			OutBuffer [ 3 ] = '3';
		if ((  param.Modes &  LSBmode ) == LSBmode  )
			OutBuffer [ 3 ] = '1';
		if ((  param.Modes &  LSBmode ) == USBmode  )
			OutBuffer [ 3 ] = '2';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	param.Modes &= ~LSBmode;
	if ( InBuffer [ 3 ] == '1' )
		param.Modes |= LSBmode;
	if ( InBuffer [ 3 ] == '2' )
		param.Modes |= USBmode;
	ModeChanged = 1;
	OutputdataDirty = 1;  // Memorize changes
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  MicGain ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'M';
    OutBuffer [ 1 ] = 'G';
    OutBuffer [ 2 ] = '1';
    OutBuffer [ 3 ] = '6';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = ';';
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  ModeKey ( void )
{	
	param.Modes &= ~LSBmode;
	if ( InBuffer [ 2 ] == '2' )
		param.Modes |= USBmode;
	if ( InBuffer [ 2 ] == '1' )
		param.Modes |= LSBmode;
	ModeChanged = 1;
	OutputdataDirty = 1;  // Memorize changes
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  MonitorLevel ( void )
{
	BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'M';
    OutBuffer [ 1 ] = 'L';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '1';
    OutBuffer [ 6 ] = ';';
   for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  MeterSw ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'M';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '3';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  MoxSet ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'M';
    OutBuffer [ 1 ] = 'X';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  Narrow ( void )
{
	BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'N';
    OutBuffer [ 1 ] = 'A';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
		if (( param.Modes & NARROWmode ) == NARROWmode )
			OutBuffer [ 3 ] = '1';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	if ( InBuffer [ 3 ] == '1' )
	{
		param.Modes |= NARROWmode;
		ResetIOBW;
	}
	else
	{
		param.Modes &= ~NARROWmode;
		SetIOBW;
	};
	OutputdataDirty = 1;  // Memorize changes
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  NoiseBlanker ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'N';
    OutBuffer [ 1 ] = 'B';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  NoiseReduction ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'N';
    OutBuffer [ 1 ] = 'R';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  PreAmpStatus ( void )
{
  BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'P';
    OutBuffer [ 1 ] = 'A';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
		if (( param.Modes & PreAmp ) == PreAmp )
			OutBuffer [ 3 ] = '1';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	
	if ( InBuffer [ 3 ] == '0' )
	{
		param.Modes &= ~PreAmp;
		ResetIOHF;
	}
	else
	{
		param.Modes |= PreAmp;
		SetIOHF;
	};
	ModeChanged = 1;  // Change DDS
	OutputdataDirty = 1; //Set/reset IO-bits
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  PowerCtrl ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'P';
    OutBuffer [ 1 ] = 'C';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = ';';
		MakeByte2string ( (char*)&OutBuffer [ 2 ] , param.bPowerSetting * 8, 0 );
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  param.bPowerSetting = ( MakeString2BYTE ( (char*)&InBuffer [ 2 ], 3 )) / 8; 
	PowerdataDirty = 1;
  ShowPower = SHOWPOWERDELAY; 
	SetPowerLevel();
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  SpeechProcessor ( void )
{
  BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'P';
    OutBuffer [ 1 ] = 'R';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if (( param.Modes & Compress ) == Compress )
			OutBuffer [ 2 ] = '1';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	if ( InBuffer [ 2 ] == '0' )
	{
		param.Modes &= ~Compress;
		ResetIOKO;
	}
	else
	{
		param.Modes |= Compress;
		SetIOKO;
	};
	ModeChanged = 1;  // Change DDS
	OutputdataDirty = 1; //Set/reset IO-bits
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  PowerSwitch ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'P';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '1';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  QuickSplit ( void )
{
	if ( bSPLITFQmode )	
	{
		bSPLITFQmode = 0;
	}
	else
	{
		bSPLITFQmode = 1;
		if (( param.Modes & BFQmode ) == BFQmode )
		{
			param.AD9834Afrequency = param.AD9834Bfrequency;
		}
		else
		{
			param.AD9834Bfrequency = param.AD9834Afrequency;
		};
	};
	OutputdataDirty = 1;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  RFattenuator ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'A';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  ClarClear ( void )
{
	if (( param.Modes & BFQmode ) == AFQmode )
	{
		AD9834RIT_Afrequency = param.AD9834Afrequency;
	}
	else if (( param.Modes & BFQmode ) == BFQmode )	
	{	
		AD9834RIT_Bfrequency = param.AD9834Bfrequency;
	};
};
 //+++++++++++++++++++++++++++++++++++++++++++++++++

  static void  ClarUp ( void )
  {
			
		WORD				wUsedOffset;
		
		wUsedOffset = MakeString2WORD ( (char*)&InBuffer [ 2 ], 4 );

		if (( param.Modes & BFQmode ) == AFQmode )
		{
			AD9834RIT_Afrequency = param.AD9834Afrequency;
			AD9834RIT_Afrequency += wUsedOffset;
		}
		else if (( param.Modes & BFQmode ) == BFQmode )	
		{	
			AD9834RIT_Bfrequency = param.AD9834Bfrequency;
			AD9834RIT_Bfrequency += wUsedOffset;
		};
 
		ModeChanged = 1;
    OutputdataDirty = 1;  // Memorize changes
    SetAD9834value();
};


//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  ClarDown ( void )
{
		WORD				wUsedOffset;
		
		wUsedOffset = MakeString2WORD ( (char*)&InBuffer [ 2 ], 4 );

		if (( param.Modes & BFQmode ) == AFQmode )
		{
			AD9834RIT_Afrequency = param.AD9834Afrequency;
			AD9834RIT_Afrequency -= wUsedOffset;
		}
		else if (( param.Modes & BFQmode ) == BFQmode )	
		{	
			AD9834RIT_Bfrequency = param.AD9834Bfrequency;
			AD9834RIT_Bfrequency -= wUsedOffset;
		};
 
		ModeChanged = 1;
    OutputdataDirty = 1;  // Memorize changes
    SetAD9834value();
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  ClarOnOff ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'T';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if (( param.Modes & RITmode ) == RITmode ) 
			OutBuffer [ 2 ] = '1';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	if (InBuffer [ 2 ] == '1' )
	{
		param.Modes |= RITmode;
		if (( param.Modes & BFQmode ) == AFQmode )
		{
			AD9834RIT_Afrequency = param.AD9834Afrequency;
		}
		else if (( param.Modes & BFQmode ) == BFQmode )	
		{	
			AD9834RIT_Bfrequency = param.AD9834Bfrequency;
		}
		else
			param.Modes &= ~RITmode;
	}
	else
	{
		param.Modes &= ~RITmode;
		if (( param.Modes & BFQmode ) == AFQmode )
		{
			AD9834RIT_Afrequency = param.AD9834Afrequency;
		}
		else if (( param.Modes & BFQmode ) == BFQmode )	
		{	
			AD9834RIT_Bfrequency = param.AD9834Bfrequency;
		};
	};
  SaveBandData ( Band, AddAD9834Afrequency, sizeof ( struct Parameters ));
	SetAD9834value();
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  RoofFilter ( void )
{
  BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'F';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '4';
    OutBuffer [ 4 ] = ';';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };

};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  RfGain ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'G';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '1';
    OutBuffer [ 4 ] = '2';
    OutBuffer [ 5 ] = '7';
    OutBuffer [ 6 ] = ';';
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  RadioInfo ( void )
{
	BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'I';
    OutBuffer [ 2 ] = InBuffer [ 2 ] ;  //
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
		if ( InBuffer [ 2 ] == '4' )
			OutBuffer [ 3 ] = '1';  //Play is ON !!!!!

    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  NoiseReductionLevel ( void )
{
  BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'L';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = ';';
		if (( param.Modes & Compress ) == Compress )
			OutBuffer [ 2 ] = '1';
    for ( count = 0; count < 5; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  ReadMeter ( void )
{
  BYTE      count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'M';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '1';
    OutBuffer [ 4 ] = '2';
    OutBuffer [ 5 ] = '7';
    OutBuffer [ 6 ] = ';';
		
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };

};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  RadioStatus ( void )
{
  BYTE      potValue, count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'R';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if ( mainmode == MENUMODE )
			OutBuffer [ 2 ] = '1';
		
		
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  Scan ( void )
{
  BYTE      count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'S';
    OutBuffer [ 1 ] = 'C';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  BreakInTime ( void )
{
  BYTE  NumberOfDigits, count, Jdx;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'S';
    OutBuffer [ 1 ] = 'D';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 6 ] = ';';
		
		MakeWord2string ( (char*)&OutBuffer [ 2 ] , wUsedDelay, 0 );
    for ( count = 0; count < 7 ; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
  wUsedDelay = MakeString2WORD ((char*)&InBuffer[ 2 ], 4 );
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Width ( void )
{
  BYTE     count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'S';
    OutBuffer [ 1 ] = 'H';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '1';
    OutBuffer [ 4 ] = '6';
    OutBuffer [ 5 ] = ';';
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
	};
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  SMeter ( void )
{
  BYTE  count;
  if  ( InputByteCount == 4 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'S';
    OutBuffer [ 1 ] = 'M';
    OutBuffer [ 2 ] = InBuffer [ 2 ];
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = ';';
		
		MakeByte2string ( (char*)&OutBuffer [ 3 ] , GetSMeterValue() * 23, 0 );
    for ( count = 0; count < 7 ; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  SwapVFO ( void )
{
  if (( param.Modes & BFQmode ) == BFQmode )
  {
    param.Modes &= ~BFQmode;
    param.Modes |= AFQmode;
  }
  else
  {
    param.Modes &= ~BFQmode;
    param.Modes |= BFQmode;
  };
  ModeChanged = 1;
  OutputdataDirty = 1;  // Memorize changes
  SetAD9834value();
};

 //+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Txw ( void )
{
  BYTE  count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'T';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  TxSet ( void )
{
  BYTE  count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'T';
    OutBuffer [ 1 ] = 'X';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if ( bSet2transmit == '1' )
		{
			OutBuffer [ 2 ] = '1';
		};
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
	if ( InBuffer[ 2 ] == '1' )
	{
		bSet2transmit = 1;
	}
	else
	{
		bSet2transmit = 0;
	}
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Unlock ( void )
{
	BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'U';
    OutBuffer [ 1 ] = 'L';
    OutBuffer [ 2 ] = '0';  //Always unlocked
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  Up ( void )
{
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  VoxDelay ( void )
{
  BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'V';
    OutBuffer [ 1 ] = 'D';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = '0';
    OutBuffer [ 6 ] = ';';
		MakeWord2string ( (char*)&OutBuffer [ 2 ] , wUsedDelay, 0 );
    for ( count = 0; count < 7; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
	};
	wUsedDelay = MakeString2WORD ( (char*)&InBuffer [ 2 ], 4 );
	if ( wUsedDelay < MIN_USED_DELAY )
		wUsedDelay = MIN_USED_DELAY;
	if ( wUsedDelay > MAXDELAY )
		wUsedDelay = MAXDELAY;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  VoxGain ( void )
{
  BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'V';
    OutBuffer [ 1 ] = 'G';
    OutBuffer [ 2 ] = '1';
    OutBuffer [ 3 ] = '0';
    OutBuffer [ 4 ] = '0';
    OutBuffer [ 5 ] = ';';
    for ( count = 0; count < 6; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
	};
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

static void  VFOselect ( void )
{
  BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'V';
    OutBuffer [ 1 ] = 'S';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
		if (( param.Modes & BFQmode ) == BFQmode )
		    OutBuffer [ 2 ] = '1';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
		return;
	};
	if ( InBuffer [ 2 ] == '0')
	{
		param.Modes = AFQmode;
	};
  if ( InBuffer [ 2 ] == '1')
  {
    param.Modes = BFQmode;
  };
	ModeChanged = 1;  // Change DDS
	OutputdataDirty = 1; //Set/reset IO-bits
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


static void  Vox ( void )
{
  BYTE     count;
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'V';
    OutBuffer [ 1 ] = 'X';
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 3 ] = ';';
    for ( count = 0; count < 4; count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
	};
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++

  void SetORsendFQvalue ( char fqmode, UINT * fqValue )
  {
  BYTE  NumberOfDigits, count, Jdx, CmdBand, FqOK = 0;
	UINT		CmdFQ;
	
  if  ( InputByteCount == 3 )  // then request for data!
  {
    OutBuffer [ 0 ] = 'F';
    OutBuffer [ 1 ] = fqmode;
    OutBuffer [ 2 ] = '0';
    OutBuffer [ 10 ] = ';';
		
		count = ulong2string ( (char*)&NumberBuffer, *fqValue );
		for ( Jdx = 0; 
					 Jdx < count; 
					 Jdx++ )
		{
			OutBuffer [ 2 + Jdx + 8 - count ] = NumberBuffer [ Jdx ];
    };
    for ( count = 0; count < ( 11 ); count++ )
      TransmitByte ( OutBuffer [ count ]);
    return;
  };
//  *fqValue = MakeString2UINT ((char*)&InBuffer[ 2 ]  );
  CmdFQ = MakeString2UINT ((char*)&InBuffer[ 2 ]  );
	CmdBand = Band;
	if (( CmdFQ > Lower160mLimit ) && ( CmdFQ < Upper160mLimit ))
	{
		CmdBand = B160;
		FqOK = 1;
	}
	else if (( CmdFQ > Lower80mLimit ) && ( CmdFQ < Upper80mLimit ))
	{
		CmdBand = B80;
		FqOK = 1;
	}
	else if (( CmdFQ > Lower40mLimit ) && ( CmdFQ < Upper40mLimit ))
	{
		CmdBand = B40;
		FqOK = 1;
	}
	else if (( CmdFQ > Lower30mLimit ) && ( CmdFQ < Upper30mLimit ))
	{
		CmdBand = B30;
		FqOK = 1;
	}
	else if (( CmdFQ > Lower20mLimit ) && ( CmdFQ < Upper20mLimit ))
	{
		CmdBand = B20;
		FqOK = 1;
	}
	else if (( CmdFQ > Lower17mLimit ) && ( CmdFQ < Upper17mLimit ))
	{
		CmdBand = B17;
		FqOK = 1;
	};
	if (( CmdBand != Band ) && ( FqOK == 1 ))
	{
		SaveBandData ( Band, AddAD9834Afrequency, sizeof ( struct Parameters ));
		Band = CmdBand;
		SetBandData ( Band );
	};
  if ( FqOK == 1 )
	{
		*fqValue = CmdFQ;
		ModeChanged = 1;  // Change DDS
		OutputdataDirty = 1; //Set/reset IO-bits
		SetAD9834value();
	};
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void NotImplemented ( void )
{
//    AT91C_BASE_PIOA->PIO_SODR = PA ;							// turn PA  on

};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void MsgNotImplemented ( void )
{
		BYTE			dummy;
		BYTE			Jdx;
		
	//Empty rest of command
	while ( DataInReceiveBuffer())
	{
		dummy = ReceiveByte();
		if ( dummy == ';' ) // up to start of next, if any...
			continue;
	};
	for ( Jdx = 0; 
				 Jdx < sizeof ( COMMAND_NOT_IMPLEMENTED ); 
				 Jdx++ )
		TransmitByte ( COMMAND_NOT_IMPLEMENTED [ Jdx ] );
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

void MsgToDisplay ( void )
{
	BYTE			dummy;
	BYTE			Jdx = 0;
	
	while ( DataInReceiveBuffer())
	{
		dummy = ReceiveByte();
		DisplayBuffer [ Jdx++ ] = dummy;
		if ( Jdx == CHAR_ON_DISPLAY )
			Jdx = CHAR_ON_DISPLAY - 1;
		if ( dummy == ';' ) // up to start of next, if any...
			goto WriteToDisplay;;
	};
WriteToDisplay:
	SendToDisplay ( (char*)&DisplayBuffer, 
			0, 
			NORMALEXETIME, 
			Jdx + 1 );

	TransmitByte ( NEW_LINE );
	TransmitByte ( RETURN );
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

UINT MakeString2UINT ( char * instring )
{
  BYTE    idx;
  BYTE  digitcount = InputByteCount - 3;
  UINT  result = 0, addvalue = 1;
  
  for ( idx = 0; idx < digitcount; idx++ )
  {
    result += addvalue * ( instring [ digitcount - idx - 1] - 0x30 );
    addvalue *= 10;
  };
  return result;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

BYTE MakeString2BYTE ( char * instring, BYTE InstringLength )
{
  BYTE    idx;
  BYTE  result = 0, addvalue = 1;
  
  for ( idx = 0; idx < InstringLength; idx++ )
  {
    result += addvalue * ( instring [ InstringLength - idx - 1 ] - 0x30 );//!!!!!20090311
    addvalue *= 10;
  };
  return result;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++

WORD MakeString2WORD ( char * instring, BYTE InstringLength )
{
  BYTE    idx;
  WORD  result = 0, addvalue = 1;
  
  for ( idx = 0; idx < InstringLength; idx++ )
  {
    result += addvalue * ( instring [ InstringLength - idx - 1 ] - 0x30 );
    addvalue *= 10;
  };
  return result;
};

//+++++++++++++++++++++++++++++++++++++++++++++++++


