/* Copyright (C) 2005 MediTalk AB 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
#ifndef __SERIAL_INCLUDED
#define __SERIAL_INCLUDED
 
/* UART Buffer Defines */
#define UART_RX_BUFFER_SIZE 4096 /* 1,2,4,8,16,32,64,128 or 256 bytes */
#define UART_TX_BUFFER_SIZE 4096 /* 1,2,4,8,16,32,64,128 or 256 bytes */
#define UART_RX_BUFFER_MASK ( UART_RX_BUFFER_SIZE - 1 )
#define UART_TX_BUFFER_MASK ( UART_TX_BUFFER_SIZE - 1 )

/* USB Buffer Defines */
#define USB_RX_BUFFER_SIZE 256 /* 1,2,4,8,16,32,64,128 or 256 bytes */
#define USB_TX_BUFFER_SIZE 64 /* 1,2,4,8,16,32,64,128 or 256 bytes */
#define USB_RX_BUFFER_MASK ( USB_RX_BUFFER_SIZE - 1 )
#define USB_TX_BUFFER_MASK ( USB_TX_BUFFER_SIZE - 1 )

#define DataInUART (UCSR1A&(1<<RXC))
#define RECEIVEBYTE UDR1
#define UARTnotREADY (UCSR1A&(1<<TXC))
#define TRANSMITBYTE UDR1

// Globals
extern volatile BYTE EndOfCommand_RS232;
extern volatile BYTE EndOfCommand_USB;
extern volatile BYTE TxCommand_RS232;
extern volatile BYTE TxCommand_USB;

/* Prototypes */
void 	InitUART_ARM ( void );
BYTE 	ReceiveByte ( void );
void 	TransmitByte( BYTE data );
BYTE DataInReceiveBuffer( void );

#endif
//End of SERIAL.H
